## kubectl config

Modify kubeconfig files

### Synopsis


Modify kubeconfig files using subcommands like "kubectl config set current-context my-context" 

The loading order follows these rules: 

  1. If the --kubeconfig flag is set, then only that file is loaded.  The flag may only be set once and no merging takes place.  
  2. If $KUBECONFIG environment variable is set, then it is used a list of paths (normal path delimitting rules for your system).  These paths are merged.  When a value is modified, it is modified in the file that defines the stanza.  When a value is created, it is created in the first file that exists.  If no files in the chain exist, then it creates the last file in the list.  
  3. Otherwise, ${HOME}/.kube/config is used and no merging takes place.

```
kubectl config SUBCOMMAND
```

### Options

```
      --kubeconfig string   use a particular kubeconfig file
```

### Options inherited from parent commands

```
      --alsologtostderr                  log to standard error as well as files
      --as string                        Username to impersonate for the operation
      --as-group stringArray             Group to impersonate for the operation, this flag can be repeated to specify multiple groups.
      --certificate-authority string     Path to a cert file for the certificate authority
      --client-certificate string        Path to a client certificate file for TLS
      --client-key string                Path to a client key file for TLS
      --cluster string                   The name of the kubeconfig cluster to use
      --context string                   The name of the kubeconfig context to use
      --insecure-skip-tls-verify         If true, the server's certificate will not be checked for validity. This will make your HTTPS connections insecure
      --log-backtrace-at traceLocation   when logging hits line file:N, emit a stack trace (default :0)
      --log-dir string                   If non-empty, write log files in this directory
      --logtostderr                      log to standard error instead of files
      --match-server-version             Require server version to match client version
  -n, --namespace string                 If present, the namespace scope for this CLI request
      --password string                  Password for basic authentication to the API server
      --request-timeout string           The length of time to wait before giving up on a single server request. Non-zero values should contain a corresponding time unit (e.g. 1s, 2m, 3h). A value of zero means don't timeout requests. (default "0")
  -s, --server string                    The address and port of the Kubernetes API server
      --stderrthreshold severity         logs at or above this threshold go to stderr (default 2)
      --token string                     Bearer token for authentication to the API server
      --user string                      The name of the kubeconfig user to use
      --username string                  Username for basic authentication to the API server
  -v, --v Level                          log level for V logs
      --vmodule moduleSpec               comma-separated list of pattern=N settings for file-filtered logging
```

### SEE ALSO
* [kubectl](kubectl.md)	 - kubectl controls the Kubernetes cluster manager
* [kubectl config current-context](kubectl_config_current-context.md)	 - Displays the current-context
* [kubectl config delete-cluster](kubectl_config_delete-cluster.md)	 - Delete the specified cluster from the kubeconfig
* [kubectl config delete-context](kubectl_config_delete-context.md)	 - Delete the specified context from the kubeconfig
* [kubectl config get-clusters](kubectl_config_get-clusters.md)	 - Display clusters defined in the kubeconfig
* [kubectl config get-contexts](kubectl_config_get-contexts.md)	 - Describe one or many contexts
* [kubectl config rename-context](kubectl_config_rename-context.md)	 - Renames a context from the kubeconfig file.
* [kubectl config set](kubectl_config_set.md)	 - Sets an individual value in a kubeconfig file
* [kubectl config set-cluster](kubectl_config_set-cluster.md)	 - Sets a cluster entry in kubeconfig
* [kubectl config set-context](kubectl_config_set-context.md)	 - Sets a context entry in kubeconfig
* [kubectl config set-credentials](kubectl_config_set-credentials.md)	 - Sets a user entry in kubeconfig
* [kubectl config unset](kubectl_config_unset.md)	 - Unsets an individual value in a kubeconfig file
* [kubectl config use-context](kubectl_config_use-context.md)	 - Sets the current-context in a kubeconfig file
* [kubectl config view](kubectl_config_view.md)	 - Display merged kubeconfig settings or a specified kubeconfig file

###### Auto generated by spf13/cobra on 10-Aug-2017
